public class Auswertung {
  // Postfix-Ausdruck wird ausgewertet

  public static void main (String[] eingabe) {
    String eingabewort = "23+19+*";
    if (eingabe.length > 0)
      eingabewort = eingabe[0];
    Zahlstapel stapel = new Zahlstapel(20);
    for (int i = 0; i < eingabewort.length(); i++) {
      char zeichen = eingabewort.charAt(i);
      if (Character.isDigit(zeichen))
        stapel.legeAuf(zeichen - '0');
      else { // Zeichen ist keine Ziffer
        int operand1 = stapel.holeVon();
        int operand2 = stapel.holeVon();
        if (zeichen == '+')
          stapel.legeAuf(operand1 + operand2);
        else if (zeichen == '*')
          stapel.legeAuf(operand1 * operand2);
        } // Ende else
      } // Ende for
    int wert = stapel.holeVon();
    if (stapel.istLeer())
      System.out.println("\n " + eingabewort + " ergibt " + wert);
    else
      System.out.println("\n Syntaxfehler!");
    } // Ende main

  } // Ende Auswertung

class Zahlstapel {
  // Implementation mittels Reihung

  int   maxLnge;
  int[] reihung;
  int   spitze;
  
  Zahlstapel (int m) {
    maxLnge = m;
    reihung = new int[maxLnge];
    spitze = -1;
    } // Ende Konstruktor

  boolean istLeer()
    {return spitze == -1;}

  boolean istVoll()
    {return spitze == maxLnge - 1;}

  void legeAuf (int zahl) {
    if (! istVoll())
      reihung[++spitze] = zahl;
    } // Ende legeAuf

  int holeVon() {
    if (istLeer()) return 0;
    return reihung[spitze--];
    } // Ende holeVon

  int liesSpitze()
    {return reihung[spitze];}
 
  } // Ende Zahlstapel

